import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { request } from '@/plugins/http-fetch';
import { parseObjLineToHump } from '@/utils/parse-utils';

/**
 * 查询软件列表
 * @param query 查询参数
 * @returns object
 */
export async function listLicense(query: Record<string, any>) {
  let totalSQL = 'select count(id) as total from ne_license ';
  let rowsSQL = ' select * from ne_license ';

  // 查询
  let querySQL = 'where 1=1';
  if (query.neType) {
    querySQL += ` and ne_type like '%${query.neType}%' `;
  }

  // 分页
  const pageNum = (query.pageNum - 1) * query.pageSize;
  const limtSql = ` order by created_at desc limit ${pageNum},${query.pageSize} `;

  // 发起请求
  const result = await request({
    url: `/api/rest/databaseManagement/v1/select/omc_db/ne_license`,
    method: 'get',
    params: {
      totalSQL: totalSQL + querySQL,
      rowsSQL: rowsSQL + querySQL + limtSql,
    },
  });

  // 解析数据
  if (result.code === RESULT_CODE_SUCCESS) {
    const data: DataList = {
      total: 0,
      rows: [],
      code: result.code,
      msg: result.msg,
    };
    result.data.data.forEach((item: any) => {
      const itemData = item['ne_license'];
      if (Array.isArray(itemData)) {
        if (itemData.length === 1 && itemData[0]['total'] >= 0) {
          data.total = itemData[0]['total'];
        } else {
          data.rows = itemData.map(v => parseObjLineToHump(v));
        }
      }
    });
    return data;
  }
  return result;
}

/**
 * 上传文件
 * @param data 表单数据对象
 * @returns object
 */
export function uploadLicense(data: FormData) {
  return request({
    url: `/api/rest/systemManagement/v1/elementType/${data.get(
      'nfType'
    )}/objectType/license?neId=${data.get('nfId')}`,
    method: 'post',
    data,
    dataType: 'form-data',
    timeout: 180_000,
  });
}
